.data
szFileError		db "Unknown file morph",0;"  ",0
szMemError		db "Not enough memory",0;"   ",0


.code

OnNewFile proc hwnd:HWND,pFileName:DWORD
	LOCAL nSize		:DWORD
	
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,64
	.if eax==0
		invoke MessageBox,hwnd,addr szMemError,\
		               	addr szAppName,MB_OK or MB_ICONSTOP
		jmp exit
	.endif
	mov pBooks,eax
;---------------------------	
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,48
	.if eax==0
		invoke MessageBox,hwnd,addr szMemError,\
		               	addr szAppName,MB_OK or MB_ICONSTOP
		jmp exit
	.endif
	mov pAuthors,eax
;---------------------------	
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,48
	.if eax==0
		invoke MessageBox,hwnd,addr szMemError,\
		               	addr szAppName,MB_OK or MB_ICONSTOP
		jmp exit
	.endif
	mov pCases,eax
;---------------------------	
	
	exit:
	ret
OnNewFile endp
OnOpenFile proc hwnd:HWND,pFileName:DWORD
	LOCAL hFile		:DWORD
	LOCAL pMem		:DWORD
	LOCAL nSize		:DWORD
	LOCAL nSizeRead	:DWORD
	LOCAL hCursor	:DWORD
	
	push ebx
	push esi
	push edi
	invoke LoadCursor,NULL, IDC_WAIT
	invoke SetCursor,eax
	mov hCursor,eax
	invoke CreateFile,pFileName,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_ALWAYS,\
								FILE_ATTRIBUTE_NORMAL,NULL
	mov hFile,eax
	invoke GetFileSize,hFile,0
	mov nSize,eax
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,eax
	.if eax==0
		invoke MessageBox,hwnd,addr szMemError,\
		               	addr szAppName,MB_OK or MB_ICONSTOP
		jmp exit
	.endif
	mov pMem,eax
	invoke SetFilePointer,hFile,0,0,FILE_BEGIN
	invoke ReadFile,hFile,pMem,nSize,addr nSizeRead,0
	
	xor eax,eax
	mov edi,pMem
	invoke lstrcmp,addr szFileID,edi
	.if eax !=0
		invoke MessageBox,hwnd,addr szFileError,\
		               	addr szAppName,MB_OK or MB_ICONSTOP
		jmp finish
	.endif
	add edi,16
	mov eax,DWORD PTR [edi]
	mov numBooks,eax
	add edi,4
	mov eax,DWORD PTR [edi]
	mov numAuthors,eax
	add edi,4
	mov eax,DWORD PTR [edi]
	mov numCases,eax
	add edi,4				;edi=pBooks in memory
	mov eax,numBooks
	shl eax,6
	mov nSize,eax
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,nSize
	.if eax==0				;eax=pBooks
		invoke MessageBox,hwnd,addr szMemError,\
		                  addr szAppName,MB_OK or MB_ICONSTOP
		jmp exit
	.endif
	mov pBooks,eax
	invoke memCopy,pBooks,edi,nSize
	add edi,nSize			;edi=pAuthors in memory
	mov eax,numAuthors
	lea eax,[eax+eax*2]
	shl eax,4
	mov nSize,eax
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,nSize
	.if eax==0				;eax=pAuthors
		invoke MessageBox,hwnd,addr szMemError,\
		                  addr szAppName,MB_OK or MB_ICONSTOP
		jmp exit
	.endif
	mov pAuthors,eax
	invoke memCopy,pAuthors,edi,nSize
	add edi,nSize			;edi=pPlaces in memory
	mov eax,numCases
	lea eax,[eax+eax*2]
	shl eax,4
	mov nSize,eax
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,nSize
	.if eax==0				;eax=pPlaces
		invoke MessageBox,hwnd,addr szMemError,\
		                  addr szAppName,MB_OK or MB_ICONSTOP
		jmp exit
	.endif
	mov pCases,eax
	invoke memCopy,pCases,edi,nSize
	
	finish:
	invoke CloseHandle,hFile
	invoke HeapFree,hHeap,0,pMem
	exit:
	invoke SetCursor,hCursor
	pop edi
	pop esi
	pop ebx
	ret
OnOpenFile endp
OnSaveFile proc hwnd:HWND,pFileName:DWORD
	LOCAL hFile			:DWORD
	LOCAL pMem			:DWORD
	LOCAL nSize			:DWORD
	LOCAL nSizeWrite	:DWORD
	LOCAL hCursor	:DWORD
	push ebx
	push esi
	push edi
	invoke LoadCursor,NULL, IDC_WAIT
	invoke SetCursor,eax
	mov hCursor,eax
	invoke CreateFile,pFileName,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_ALWAYS,\
								FILE_ATTRIBUTE_NORMAL,NULL
	mov hFile,eax
	mov nSize,28
	mov eax,numBooks
	shl eax,6
	add nSize,eax
	mov eax,numAuthors
	lea eax,[eax+eax*2]
	shl eax,4
	add nSize,eax
	mov eax,numCases
	lea eax,[eax+eax*2]
	shl eax,4
	add nSize,eax
 	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,nSize
	.if eax==0
		invoke MessageBox,hwnd,addr szMemError,\
		               	addr szAppName,MB_OK or MB_ICONSTOP
		jmp exit
	.endif
	mov pMem,eax
	mov edi,eax
	invoke strCopy,edi,addr szFileID
	add edi,16
	mov eax,numBooks
	mov DWORD PTR [edi],eax
	add edi,4
	mov eax,numAuthors
	mov DWORD PTR [edi],eax
	add edi,4
	mov eax,numCases
	mov DWORD PTR [edi],eax
	add edi,4					;edi=pBooks in memory
	mov esi,numBooks
	shl esi,6
	invoke memCopy,edi,pBooks,esi
;----------------------
	add edi,esi					;edi=pAuthors in memory
	mov esi,numAuthors
	lea esi,[esi+esi*2]
	shl esi,4
	invoke memCopy,edi,pAuthors,esi
;----------------------
	add edi,esi					;edi=pPlaces in memory
	mov esi,numCases
	lea esi,[esi+esi*2]
	shl esi,4
	invoke memCopy,edi,pCases,esi
;----------------------
	invoke WriteFile,hFile,pMem,nSize,addr nSizeWrite,0
	invoke SetEndOfFile,hFile
	finish:
	invoke CloseHandle,hFile
	invoke HeapFree,hHeap,0,pMem
	invoke SendMessage,hToolbar,TB_ENABLEBUTTON,IDM_FILE_SAVE,FALSE
	exit:
	invoke SetCursor,hCursor
	pop edi
	pop esi
	pop ebx
	ret
	ret
OnSaveFile endp
EmptyBuffer proc pBuffer:DWORD,nSize:DWORD
	mov edx,pBuffer
	shr nSize,2
	xor ecx,ecx
	emptyLoop:
		mov DWORD PTR [edx+ecx*4],DWORD PTR 0
		inc ecx
		cmp ecx,nSize
		jne emptyLoop
		endLoop:
	ret
EmptyBuffer endp
lnString proc pStr:DWORD
	xor eax,eax
	mov ecx,pStr
	lnLoop:
		mov dl,byte ptr [ecx+eax]
		inc eax
		cmp dl,byte ptr 0
		jne lnLoop
	dec eax
	ret
lnString endp 
strCopy proc pDest:DWORD,pSource:DWORD
	mov ecx, pSource	
    mov edx, pDest		
    copyLoop:
    	mov al,byte ptr [ecx]   
    	inc ecx			
    	mov byte ptr [edx],al
    	inc edx			
    	cmp al,0		
    	jne copyLoop	
	ret
strCopy endp
memCopy proc pDest:DWORD,pSource:DWORD,nSize:DWORD
	push esi
	mov edx,pDest
	mov esi,pSource
	shr nSize,2
	xor ecx,ecx
	copyLoop:
		mov eax,DWORD PTR [esi+ecx*4]
		mov DWORD PTR [edx+ecx*4],eax
		inc ecx
		cmp ecx,nSize
		jb copyLoop
	pop esi
	ret
memCopy endp
RemoveAuBook proc hwnd:HWND,nID:DWORD
	push esi
	ASSUME esi:PTR AUTHORS
	mov esi,pAuthors
	mov eax,nID
	xor ecx,ecx
	AuLoop:
		mov edx,ecx
		lea edx,[edx+edx*2]
		shl edx,4
		cmp [esi+edx].ID,eax
		je exitLoop
		inc ecx
		cmp ecx,numAuthors
		jb AuLoop
	exitLoop:
	;-------------------------------
	dec [esi+edx].numBooks
	.if [esi+edx].numBooks==0
		mov eax,ecx				;ecx=index
		inc eax					;eax=next index
		.if eax==numAuthors
			jmp noCopy
		.else
			mov edx,numAuthors
			sub edx,eax
			lea edx,[edx+edx*2]
			shl edx,4			;edx=size
			lea ecx,[ecx+ecx*2]
			shl ecx,4			;offset dest
			lea eax,[eax+eax*2]
			shl eax,4			;offset source
			add ecx,esi			;ecx=pDest
			add eax,esi			;eax=pSourse
			invoke memCopy,ecx,eax,edx
		.endif
		noCopy:
		dec numAuthors
		mov eax,numAuthors
		lea eax,[eax+eax*2]
		shl eax,4
		invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
									pAuthors,eax
		.if eax==0			;eax=new pAuthors
			invoke MessageBox,hwnd,addr szMemError,\
		               	addr szAppName,MB_OK or MB_ICONSTOP
			ASSUME esi:nothing
			pop esi
			xor eax,eax
			ret
		.endif
	.else	
		xor eax,eax
	.endif
	ASSUME esi:nothing
	pop esi
	ret						;return pAuthors
RemoveAuBook endp
SetAuthor proc nID:DWORD
	push esi
	ASSUME esi:PTR AUTHORS
	mov esi,pAuthors
	mov eax,nID
	xor ecx,ecx
	auLoop:
		mov edx,ecx
		lea edx,[edx+edx*2]
		shl edx,4
		cmp [esi+edx].ID,eax
		je exitLoop
		inc ecx
		cmp ecx,numAuthors
		jb auLoop
	exitLoop:
	inc [esi+edx].numBooks
	mov eax,[esi+edx].ID				;eax=ID new Author
	ASSUME esi:nothing
	pop esi
	ret
SetAuthor endp
AddAuthor proc hwnd:HWND,pAuName:LPSTR,pID:DWORD
	push esi
	ASSUME esi:PTR AUTHORS

	inc numAuthors
	mov eax,numAuthors
	lea eax,[eax+eax*2]
	shl eax,4			;eax=size of Authors
	invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,\
							pAuthors,eax
	.if eax==0
		invoke MessageBox,hwnd,addr szMemError,\
		              addr szAppName,MB_OK or MB_ICONSTOP
		dec numAuthors
		xor eax,eax
		pop esi
		ret
	.endif
	mov esi,eax				;esi=pAuthors
	mov eax,numAuthors
	.if eax==1
		mov ecx,eax
		dec ecx
		lea ecx,[ecx+ecx*2]
		shl ecx,4
		mov [esi+ecx].ID,eax
	.elseif eax>1
		mov ecx,eax
		sub ecx,2
		lea ecx,[ecx+ecx*2]
		shl ecx,4
		mov eax,[esi+ecx].ID
		inc eax
		mov ecx,numAuthors
		dec ecx
		lea ecx,[ecx+ecx*2]
		shl ecx,4
		mov [esi+ecx].ID,eax
	.endif	
	mov [esi+ecx].numBooks,1
	mov edx,pID
	mov DWORD PTR [edx],eax
	invoke memCopy,addr [esi+ecx].szName,pAuName,40
	mov eax,esi		;return pAuthors
	ASSUME esi:nothing
	pop esi
	ret
AddAuthor endp










